import type { PICKED_PKG_FIELDS } from "../../../constants";
import type { AtomComponentAsset } from 'dumi-assets-types';
import { type ComponentType } from 'react';
import type { ILocalesConfig, IPreviewerProps, IRouteMeta, IThemeConfig } from '../types';
export type DemoInfo = {
    component: ComponentType;
    asset: IPreviewerProps['asset'];
    routeId: string;
};
interface ISiteContext {
    pkg: Partial<Record<keyof typeof PICKED_PKG_FIELDS, any>>;
    historyType: 'browser' | 'hash' | 'memory';
    entryExports: Record<string, any>;
    demos: Record<string, DemoInfo>;
    components: Record<string, AtomComponentAsset>;
    tabs: IRouteMeta['tabs'];
    locales: ILocalesConfig;
    themeConfig: IThemeConfig;
    hostname?: string;
    loading: boolean;
    setLoading: (status: boolean) => void;
    /**
     * private field, do not use it in your code
     */
    _2_level_nav_available: boolean;
    getDemoById: (id: string) => Promise<DemoInfo | null>;
}
export declare const SiteContext: import("react").Context<ISiteContext>;
export declare const useSiteData: () => ISiteContext;
export declare function useDemoData(demoId: string): DemoInfo | null;
export {};
