function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { evalCode } from 'dumi';
import React, { useMemo, useState } from 'react';
import ReactDOM from 'react-dom/server';
import { transform } from 'sucrase';
import { useDemoScopes } from "./useDemoScopes";
export var LiveContext = /*#__PURE__*/React.createContext({
  enabled: false,
  code: '',
  onCodeChange: function onCodeChange() {},
  demo: null,
  error: ''
});
var transformCode = function transformCode(code, scopes) {
  if (!scopes) {
    return /*#__PURE__*/React.createElement(React.Fragment, null);
  }
  var Comp = evalCode(transform(code, {
    transforms: ['typescript', 'jsx']
  }).code, scopes);
  return /*#__PURE__*/React.createElement(Comp, null);
};
export var LiveProvider = function LiveProvider(_ref) {
  var initialCode = _ref.initialCode,
    demoId = _ref.demoId,
    children = _ref.children;
  var scopes = useDemoScopes(demoId);
  var _useState = useState(initialCode),
    _useState2 = _slicedToArray(_useState, 2),
    code = _useState2[0],
    setCode = _useState2[1];
  var _useState3 = useState(function () {
      return transformCode(code, scopes);
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    demo = _useState4[0],
    setDemo = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    error = _useState6[0],
    setError = _useState6[1];
  var onCodeChange = function onCodeChange(newCode) {
    setCode(newCode);
    try {
      var liveDemo = transformCode(newCode, scopes);
      ReactDOM.renderToString(liveDemo);
      setDemo(liveDemo);
      setError('');
    } catch (e) {
      setError(e.message);
    }
  };
  var contextValue = useMemo(function () {
    return {
      error: error,
      enabled: scopes !== null,
      demo: demo,
      code: code,
      onCodeChange: onCodeChange
    };
  }, [code, scopes, demo, error]);
  if (!scopes) {
    return children;
  }
  return /*#__PURE__*/React.createElement(LiveContext.Provider, {
    value: contextValue
  }, children);
};
export default LiveProvider;