function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
import { getRouteMetaById, matchRoutes, useAppData, useLocation, useRouteData } from 'dumi';
import { useMemo } from 'react';
import use from "./context/use";
var cache = new Map();
var useAsyncRouteMeta = function useAsyncRouteMeta(id) {
  if (!cache.has(id)) {
    cache.set(id, getRouteMetaById(id));
  }
  return use(cache.get(id));
};
var emptyMeta = {
  frontmatter: {},
  toc: [],
  texts: []
};

/**
 * hook for get matched route meta
 */
export var useRouteMeta = function useRouteMeta() {
  var _useRouteData = useRouteData(),
    route = _useRouteData.route;
  var _useLocation = useLocation(),
    pathname = _useLocation.pathname;
  var _useAppData = useAppData(),
    clientRoutes = _useAppData.clientRoutes;
  var curRoute = useMemo(function () {
    if (route.path === pathname && !('isLayout' in route)) {
      // use `useRouteData` result if matched, for performance
      return route;
    } else {
      var _matchRoutes;
      // match manually for dynamic route & layout component
      var matched = (_matchRoutes = matchRoutes(clientRoutes, pathname)) === null || _matchRoutes === void 0 ? void 0 : _matchRoutes.pop();
      return matched === null || matched === void 0 ? void 0 : matched.route;
    }
  }, [clientRoutes.length, pathname]);
  var meta = useAsyncRouteMeta(curRoute === null || curRoute === void 0 ? void 0 : curRoute.id) || emptyMeta;
  if (curRoute && 'meta' in curRoute && _typeof(curRoute.meta) === 'object') {
    Object.keys(curRoute.meta).forEach(function (key) {
      var _ref, _ref$key;
      (_ref$key = (_ref = meta)[key]) !== null && _ref$key !== void 0 ? _ref$key : _ref[key] = curRoute.meta[key];
    });
  }
  return meta;
};