var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/features/live.ts
var live_exports = {};
__export(live_exports, {
  default: () => live_default
});
module.exports = __toCommonJS(live_exports);
var import_constants = require("../constants");
var import_tabs = require("./tabs");
var import_path = require("path");
var import_plugin_utils = require("umi/plugin-utils");
var live_default = (api) => {
  const mdFiles = [];
  api.describe({
    key: "live",
    config: {
      schema(joi) {
        return joi.boolean();
      }
    },
    enableBy: api.EnableBy.register
  });
  api.register({
    key: "modifyRoutes",
    // make sure it is called last
    stage: Infinity,
    fn: (routes) => {
      mdFiles.length = 0;
      Object.values(routes).forEach((route) => {
        if (!route.isLayout && !/\*|:/.test(route.path) && route.file && !(0, import_tabs.isTabRouteFile)(route.file) && route.file.endsWith(".md")) {
          mdFiles.push({
            index: mdFiles.length,
            file: (0, import_plugin_utils.winPath)(route.file),
            id: route.id
          });
        }
      });
      return routes;
    }
  });
  api.onGenerateFiles(async () => {
    api.writeTmpFile({
      noPluginDir: true,
      path: "dumi/live/demo-scopes.ts",
      tplPath: (0, import_plugin_utils.winPath)(
        (0, import_path.join)(
          import_constants.TEMPLATES_DIR,
          "live",
          !!api.config.live ? "demo-scopes.ts.tpl" : "disabled.ts.tpl"
        )
      ),
      context: {
        metaFiles: mdFiles
      }
    });
  });
};
